/*
 * Sonatype Nexus (TM) Open Source Version
 * Copyright (c) 2008-present Sonatype, Inc.
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/oss/attributions.
 *
 * This program and the accompanying materials are made available under the terms of the Eclipse Public License Version 1.0,
 * which accompanies this distribution and is available at http://www.eclipse.org/legal/epl-v10.html.
 *
 * Sonatype Nexus (TM) Professional Version is available from Sonatype, Inc. "Sonatype" and "Sonatype Nexus" are trademarks
 * of Sonatype, Inc. Apache Maven is a trademark of the Apache Software Foundation. M2eclipse is a trademark of the
 * Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * Save search filter window.
 *
 * @since 3.0
 */
Ext.define('NX.coreui.view.search.SaveSearchFilter', {
  extend: 'NX.view.AddPanel',
  alias: 'widget.nx-coreui-search-save',
  requires: [
    'NX.I18n'
  ],

  /**
   * @override
   */
  initComponent: function() {
    Ext.apply(this, {
      title: NX.I18n.get('Search_SaveSearchFilter_Title'),
      defaultFocus: 'name',

      settingsForm: {
        xtype: 'nx-settingsform',
        items: [
          {
            xtype: 'textfield',
            name: 'name',
            itemId: 'name',
            fieldLabel: NX.I18n.get('Search_SaveSearchFilter_Name_FieldLabel')
          },
          {
            xtype: 'textfield',
            name: 'description',
            fieldLabel: NX.I18n.get('Search_SaveSearchFilter_Description_FieldLabel'),
            allowBlank: true
          }
        ]
      }
    });

    this.callParent();
  }

});
