/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * License User store.
 *
 * @since 3.0
 */
Ext.define('NX.proui.store.LicenseUser', {
  extend: 'Ext.data.Store',
  model: 'NX.proui.model.LicenseUser',

  proxy: {
    type: 'direct',
    paramsAsHash: false,

    api: {
      read: 'NX.direct.licensing_Licensing.readLicenseUsers'
    },

    reader: {
      type: 'json',
      root: 'data',
      successProperty: 'success'
    }
  },

  sorters: { property: 'ip', direction: 'ASC' }
});
