/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * CLM dashboard view.
 *
 * @since 3.0
 */
Ext.define('NX.proui.view.clm.ClmDashboard', {
  extend: 'Ext.panel.Panel',
  alias: 'widget.nx-proui-clm-dashboard',

  /**
   * @override
   */
  initComponent: function () {
    var me = this;

    me.items = [
      {
        xtype: 'box',
        html: '<p>Visit the <a href="http://www.sonatype.com/clm" target="_blank">IQ Server</a> dashboard to manage applications, organizations and policies.</p>',
        margin: 10
      },
      {
        xtype: 'nx-settingsform',
        buttons: [
          {
            xtype: 'button',
            action: 'open',
            ui: 'nx-primary',
            text: 'Open IQ Server Dashboard',
            glyph: 'xf08e@FontAwesome' /* fa-external-link */
          }
        ]
      }
    ];

    me.callParent();
  }
});
