/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * Application strings
 *
 * @since 3.0
 */
Ext.define('NX.proui.app.PluginStrings', {
  '@aggregate_priority': 90,

  singleton: true,
  requires: [
    'NX.I18n'
  ],

  /*
   * Note: Symbols follow the following naming convention:
   * <Class>_<Name>_<Component or Attribute>
   */

  keys: {
    // Admin -> Security -> Atlassian Crowd
    Crowd_Text: 'Atlassian Crowd',
    Crowd_Description: 'Manage Atlassian Crowd configuration',
    Crowd_CrowdSettings_Update_Error: 'You do not have permission to configure Atlassian Crowd',
    Crowd_CrowdSettings_Update_Success: 'Atlassian Crowd settings $action',
    Crowd_CrowdSettings_Html: '<p>Application can be configured to use <a href="https://www.atlassian.com/software/crowd" target="_blank">Atlassian Crowd</a> for user database and authentication.</p>',
    Crowd_CrowdSettings_Enable_FieldLabel: 'Enable Crowd',
    Crowd_CrowdSettings_Activate_FieldLabel: 'Enable Crowd Realm for authentication',
    Crowd_CrowdSettings_Activate_HelpText: 'To control ordering, go to the <a href="#admin/security/realms">Realms</a> page.',
    Crowd_CrowdSettings_URL_FieldLabel: 'Crowd server URL',
    Crowd_CrowdSettings_URL_HelpText: 'For example: http://localhost:8095/crowd',
    Crowd_CrowdSettings_Name_FieldLabel: 'Crowd application name',
    Crowd_CrowdSettings_Password_FieldLabel: 'Crowd application password',
    Crowd_CrowdSettings_Request_FieldLabel: 'Connection timeout',
    Crowd_CrowdSettings_Request_HelpText: 'Seconds to wait for activity before stopping and retrying the connection. Leave blank to use the globally defined HTTP timeout.',
    Crowd_CrowdSettings_VerifyConnection_Text: 'Verify connection',
    Crowd_CrowdSettings_Verified_Success: 'Connection to Crowd server verified: {0}',

    // Admin -> Security -> User Token
    UserToken_Text: 'User Tokens',
    UserToken_Description: 'Manage user token configuration',
    UserTokenSettings_Update_Error: 'You do not have permission to configure user token',
    UserTokenSettings_Update_Success: 'User Token settings $action',
    UserTokenSettings_Html: '<p>The user token feature allows users to authenticate securely ' +
    'without typical user credentials such as those used by LDAP or Crowd.</p>' +
    '<p>User tokens generated for this server are only valid for use on this server. Once enabled, users can access ' +
    'their user token from <a href="#user/usertoken">user mode</a>.</p>',
    UserTokenSettings_Enable_FieldLabel: 'Enable user tokens',
    UserTokenSettings_Require_FieldLabel: 'Require user tokens for repository authentication',
    UserTokenSettings_Require_HelpText: 'This does not affect UI access',
    UserTokenSettings_Reset_Title: 'Reset user tokens',
    UserTokenSettings_Reset_Html: '<p>Reset will invalidate <b>ALL</b> existing user tokens and force new tokens to be created the next time they are accessed.</p>',
    UserTokenSettings_ResetAll_Button: 'Reset all user tokens',
    UserToken_Authentication_Validation: '{0} user tokens requires validation of your credentials.',
    UserToken_ResetAll_Success: 'All user tokens have been reset',
    UserToken_Reset_Success: 'Your user token has been reset',
    UserToken_ResetById_Message: 'User token of {0} has been reset',

    // Admin -> Security -> User Token -> Reset Token
    UserToken_UserTokenUser_Title: 'User Token',
    UserToken_UserTokenUser_ResetToken_Title: 'Reset user token',
    UserToken_UserTokenUser_ResetToken_Html: '<p>Resetting a user’s token will invalidate their current token and force a new token to be created the next time it is accessed by the user.</p>',
    UserToken_UserTokenUser_ResetToken_Button: 'Reset user token',

    // Admin -> System -> Licensing
    Licensing_Text: 'Licensing',
    Licensing_Description: 'A valid license is required. Manage it here.',
    Licensing_LicensingDetails_Company_FieldLabel: 'Company',
    Licensing_LicensingDetails_Name_FieldLabel: 'Name',
    Licensing_LicensingDetails_Email_FieldLabel: 'Email',
    Licensing_LicensingDetails_EffectiveDate_FieldLabel: 'Effective date',
    Licensing_LicensingDetails_ExpirationDate_FieldLabel: 'Expiration date',
    Licensing_LicensingDetails_Type_FieldLabel: 'License type',
    Licensing_LicensingDetails_Connections_FieldLabel: 'Licensed connections',
    Licensing_LicensingDetails_InstallLicense_Title: 'Install license',
    Licensing_LicensingDetails_InstallLicense_Html: '<p>Installing a new license may interrupt service briefly</p>',
    Licensing_LicensingDetails_LicenseSelect_Button: 'Select license&hellip;',
    Licensing_LicensingDetails_LicenseInstall_Button: 'Install license',
    Licensing_LicensingDetails_LicenseUninstall_Title: 'Uninstall license',
    Licensing_LicensingDetails_LicenseUninstall_Html: 'Uninstalling the license will ' +
    'revert to the original unlicensed state. Service will be interrupted until a new license is installed.',
    Licensing_LicensingDetails_LicenseUninstall_Button: 'Uninstall license',
    Licensing_LicenseAgreement_Title: 'Nexus Repository Manager License Agreement',
    Licensing_LicenseAgreement_Yes_Button: 'I agree',
    Licensing_LicenseAgreement_No_Button: 'I do not agree',
    Licensing_LicenseAgreement_Download_Button: 'Download a copy of the license.',
    Licensing_Install_Success: 'License installed',
    Licensing_Uninstall_Success: 'License uninstalled',
    Licensing_Authentication_Validation: '{0} a license requires validation of your credentials.',

    // Admin -> System -> Licensing -> License Users
    LicenseUsers_Title: 'License Users',
    LicenseUsers_Description: 'Reports active licensed users in the last 7 days',
    Licensing_LicenseUserList_Download_Button: 'Download',
    Licensing_LicenseUserList_IP_Header: 'IP',
    Licensing_LicenseUserList_Date_Header: 'Date',
    Licensing_LicenseUserList_User_Header: 'User',
    Licensing_LicenseUserList_Agent_Header: 'User agent',
    Licensing_LicenseUserList_EmptyText: 'No licensed users in the last 7 days.',

    // User -> User Token
    UserToken_Text: 'User Token',
    UserToken_Description: 'Access Nexus without the use of passwords',
    UserToken_UserTokenCurrent_Access_Title: 'Access your token',
    UserToken_UserTokenCurrent_Access_Html: 'A new user token will be created the first time it is accessed.',
    UserToken_UserTokenCurrent_Access_Button: 'Access user token',
    UserToken_UserTokenCurrent_Reset_Title: 'Reset your token',
    UserToken_UserTokenCurrent_Reset_Html: 'Resetting your user token will invalidate the current token and force a new token to be created the next time it is accessed.',
    UserToken_UserTokenCurrent_Reset_Button: 'Reset user token',

    // User -> User Token -> Access Token
    UserToken_UserTokenDetails_Title: 'User Token',
    UserToken_UserTokenDetails_Html1: 'User tokens are a combination of a name and password codes. <strong>Keep these codes secret.</strong>',
    UserToken_UserTokenDetails_Html2: '<p>Your user token is</p>',
    UserToken_UserTokenDetails_Html3: '<p>Use the following in your Maven settings.xml:</p>',
    UserToken_UserTokenDetails_AutoClose_Html: 'This window will automatically close after one minute.',
    UserToken_UserTokenDetails_AutoClosing_Message: 'Automatically closing user token details due to timeout',

    //Nexus Lifecycle -> Server
    Clm_ClmSettings_Permission_Error: 'You do not have permission to configure IQ Server',
    Clm_Text: 'Server',
    Clm_Description: 'Manage IQ Server configuration',
    Clm_Connection_Success: 'Connection to IQ Server verified: {0}',
    Clm_Dashboard_Title: 'Dashboard',
    Clm_Dashboard_Description : 'Open IQ Server Dashboard',
    ClmSettings_Html: '<p><a href="http://www.sonatype.com/nexus/product-overview/nexus-lifecycle" target="_blank">IQ Server</a> ' +
    'can evaluate application and organization policies.</p>' +
    '<p>To enable this feature configure the IQ Server URL, username and password.</p>',

    Clm_SettingsTestResults_Title: 'Applications',
    Clm_SettingsTestResults_EmptyText: 'No applications found',
    Clm_SettingsTestResults_Id_Header: 'Id',
    Clm_SettingsTestResults_Name_Header: 'Name',

    ClmSettings_Enable_FieldLabel: 'Enable IQ Server',
    ClmSettings_Enable_HelpText: 'Whether to use IQ Server.',
    ClmSettings_URL_FieldLabel: 'IQ Server server URL',
    ClmSettings_URL_HelpText: 'The address of your IQ Server.',
    ClmSettings_URL_EmptyText: 'enter a URL',
    ClmSettings_Username_FieldLabel: 'Username',
    ClmSettings_Username_HelpText: 'User with access to IQ Server.',
    ClmSettings_Username_EmptyText: 'enter a name',
    ClmSettings_Password_FieldLabel: 'Password',
    ClmSettings_Password_HelpText: 'Credentials for the IQ Server User.',
    ClmSettings_Password_EmptyText: 'enter a password',
    ClmSettings_ConnectionTimeout_FieldLabel: 'Connection Timeout',
    ClmSettings_ConnectionTimeout_HelpText: 'Seconds to wait for activity before stopping and retrying the connection. Leave blank to use the globally defined HTTP timeout.',
    ClmSettings_ConnectionTimeout_EmptyText: 'enter a timeout',
    ClmSettings_Properties_FieldLabel: 'Properties',
    ClmSettings_Properties_HelpText: 'Additional properties to configure for IQ Server.',
    ClmSettings_Properties_EmptyText: 'enter properties',
    ClmSettings_Properties_Verify_Button: 'Verify connection',

    // Healthcheck results
    HealthCheckInfo_Security_Alerts_Label: 'Security',
    HealthCheckInfo_License_Threat_Label: 'License ',
    HealthCheckInfo_Tooltip: 'License and security data is only available with a paid license.',
    HealthCheckInfo_LoggedInOnly_Tooltip: 'The license and security data is only available once you have logged in.',
    HealthCheckInfo_NoPermission_Tooltip: 'You do not have permission to view the license and security data.'
  }
}, function(obj) {
  NX.I18n.register(obj);
});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * ProUi plugin configuration.
 *
 * @since 3.0
 */
Ext.define('NX.proui.app.PluginConfig', {
  '@aggregate_priority': 100,

  requires: [
    'NX.State',
    'NX.proui.app.PluginStrings'
  ],

  controllers: [
    { id: 'NX.proui.controller.Clm',
      active: function () {
        return NX.State.getValue('clm', {})['licenseValid']
            && NX.app.Application.bundleActive('com.sonatype.nexus.plugins.nexus-clm-plugin');
      }
    },
    { id: 'NX.proui.controller.Crowd',
      active: function () {
        return NX.State.getValue('crowd', {})['licenseValid']
            && NX.app.Application.bundleActive('com.sonatype.nexus.plugins.nexus-crowd-plugin');
      }
    },
    'NX.proui.controller.FeatureGroups',
    { id: 'NX.proui.controller.HealthCheckRepositoryDetail',
      active: function () {
        return NX.app.Application.bundleActive('com.sonatype.nexus.plugins.nexus-clm-plugin');
      }
    },
    { id: 'NX.proui.controller.HealthCheckAssetDetail',
      active: function () {
        return NX.app.Application.bundleActive('com.sonatype.nexus.plugins.nexus-clm-plugin');
      }
    },
    { id: 'NX.proui.controller.HealthCheckInfo',
      active: function () {
        return NX.app.Application.bundleActive('com.sonatype.nexus.plugins.nexus-clm-plugin');
      }
    },
    { id: 'NX.proui.controller.Licensing',
      active: function () {
        return NX.app.Application.bundleActive('com.sonatype.nexus.plugins.nexus-licensing-plugin');
      }
    },
    { id: 'NX.proui.controller.LicenseUsers',
      active: function () {
        return NX.app.Application.bundleActive('com.sonatype.nexus.plugins.nexus-licensing-plugin');
      }
    },
    {
      id: 'NX.proui.controller.Nodes',
      active: function () {
        return NX.app.Application.bundleActive('com.sonatype.nexus.plugins.nexus-hazelcast-plugin');
      }
    },
    { id: 'NX.proui.controller.UserToken',
      active: function () {
        return NX.State.getValue('usertoken', {})['licenseValid']
            && NX.app.Application.bundleActive('com.sonatype.nexus.plugins.nexus-usertoken-plugin');
      }
    }
  ]
});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * Usertoken user tab.
 *
 * @since 3.0
 */
Ext.define('NX.proui.view.usertoken.UserTokenUser', {
  extend: 'NX.view.SettingsPanel',
  alias: 'widget.nx-proui-usertoken-user',
  requires: [
    'NX.I18n'
  ],

  /**
   * @override
   */
  initComponent: function() {
    Ext.apply(this, {
      title: NX.I18n.get('UserToken_UserTokenUser_Title'),

      settingsForm: [
        {
          xtype: 'nx-settingsform',
          itemId: 'resetAll',
          title: NX.I18n.get('UserToken_UserTokenUser_ResetToken_Title'),

          items: [
            {
              xtype: 'label',
              html: NX.I18n.get('UserToken_UserTokenUser_ResetToken_Html')
            }
          ],

          buttonAlign: 'left',
          buttons: [
            { text: NX.I18n.get('UserToken_UserTokenUser_ResetToken_Button'), action: 'reset', ui: 'nx-primary', glyph: 'xf023@FontAwesome' /* fa-lock */ }
          ]
        }
      ]
    });

    this.callParent();
  }

});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * Current user, usertoken settings form.
 *
 * @since 3.0
 */
Ext.define('NX.proui.view.usertoken.UserTokenCurrent', {
  extend: 'NX.view.SettingsPanel',
  alias: 'widget.nx-proui-usertoken-current',
  requires: [
    'NX.I18n'
  ],

  /**
   * @override
   */
  initComponent: function() {
    Ext.apply(this, {
      settingsForm: [
        {
          xtype: 'form',
          ui: 'nx-subsection',
          frame: true,
          title: NX.I18n.get('UserToken_UserTokenCurrent_Access_Title'),

          items: [
            {
              xtype: 'label',
              html: NX.I18n.get('UserToken_UserTokenCurrent_Access_Html')
            }
          ],

          buttonAlign: 'left',
          buttons: [
            { text: NX.I18n.get('UserToken_UserTokenCurrent_Access_Button'), action: 'access', ui: 'nx-primary', glyph: 'xf023@FontAwesome' /* fa-lock */ }
          ]
        },
        {
          xtype: 'form',
          ui: 'nx-subsection',
          frame: true,
          title: NX.I18n.get('UserToken_UserTokenCurrent_Reset_Title'),

          items: [
            {
              xtype: 'label',
              html: NX.I18n.get('UserToken_UserTokenCurrent_Reset_Html')
            }
          ],

          buttonAlign: 'left',
          buttons: [
            { text: NX.I18n.get('UserToken_UserTokenCurrent_Reset_Button'), action: 'reset', glyph: 'xf023@FontAwesome' /* fa-lock */ }
          ]
        }
      ]
    });

    this.callParent();
  }

});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * License Agreement window.
 *
 * @since 3.0
 */
Ext.define('NX.proui.view.licensing.LicenseAgreement', {
  extend: 'Ext.window.Window',
  alias: 'widget.nx-proui-licensing-agreement',
  requires: [
    'NX.util.Url',
    'NX.I18n'
  ],

  /**
   * @override
   */
  initComponent: function () {
    var me = this;

    me.title = NX.I18n.get('Licensing_LicenseAgreement_Title');

    me.layout = 'fit';
    me.autoShow = true;
    me.modal = true;
    me.constrain = true;
    me.width = 640;
    me.height = 500;

    me.items = {
      xtype: 'box',
      autoEl: {
        tag: 'iframe',
        src: NX.util.Url.urlOf('/LICENSE.html')
      }
    };

    me.dockedItems = [
      {
        xtype: 'toolbar',
        dock: 'bottom',
        ui: 'footer',
        items: [
          { xtype: 'button', text: NX.I18n.get('Licensing_LicenseAgreement_Yes_Button'), action: 'agree', formBind: true, ui: 'nx-primary' },
          { xtype: 'button', text: NX.I18n.get('Licensing_LicenseAgreement_No_Button'), handler: function () {
            this.up('window').close();
          }},
          '->',
          { xtype: 'component', html: '<a href="' + NX.util.Url.urlOf('/LICENSE.html') +
              '" target="_new">' + NX.I18n.get('Licensing_LicenseAgreement_Download_Button') + '</a>'
          }
        ]
      }
    ];

    me.callParent();
  }

});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * Crowd settings form.
 *
 * @since 3.0
 */
Ext.define('NX.proui.view.crowd.CrowdSettings', {
  extend: 'NX.view.SettingsPanel',
  alias: 'widget.nx-proui-crowd-settings',
  requires: [
    'NX.Conditions',
    'NX.I18n'
  ],

  /**
   * @override
   */
  initComponent: function () {
    var me = this;

    me.settingsForm = {
      xtype: 'nx-settingsform',
      settingsFormSuccessMessage: NX.I18n.get('Crowd_CrowdSettings_Update_Success'),
      api: {
        load: 'NX.direct.crowd_Crowd.read',
        submit: 'NX.direct.crowd_Crowd.update'
      },
      editableCondition: NX.Conditions.isPermitted('nexus:crowd:update'),
      editableMarker: NX.I18n.get('Crowd_CrowdSettings_Update_Error'),

      items: [
        {
          xtype: 'label',
          html: NX.I18n.get('Crowd_CrowdSettings_Html')
        },
        {
          xtype: 'checkbox',
          name: 'enabled',
          fieldLabel: NX.I18n.get('Crowd_CrowdSettings_Enable_FieldLabel')
        },
        {
          xtype: 'checkbox',
          name: 'realmActive',
          fieldLabel: NX.I18n.get('Crowd_CrowdSettings_Activate_FieldLabel'),
          helpText: NX.I18n.get('Crowd_CrowdSettings_Activate_HelpText')
        },
        {
          xtype: 'nx-url',
          name: 'url',
          fieldLabel: NX.I18n.get('Crowd_CrowdSettings_URL_FieldLabel'),
          helpText: NX.I18n.get('Crowd_CrowdSettings_URL_HelpText')
        },
        {
          name: 'applicationName',
          fieldLabel: NX.I18n.get('Crowd_CrowdSettings_Name_FieldLabel')
        },
        {
          xtype: 'nx-password',
          name: 'applicationPassword',
          fieldLabel: NX.I18n.get('Crowd_CrowdSettings_Password_FieldLabel')
        },
        {
          xtype: 'numberfield',
          name: 'timeout',
          fieldLabel: NX.I18n.get('Crowd_CrowdSettings_Request_FieldLabel'),
          helpText: NX.I18n.get('Crowd_CrowdSettings_Request_HelpText'),
          allowBlank: true,
          allowDecimals: false,
          allowExponential: false,
          minValue: 1,
          maxValue: 3600
        }
      ]
    };

    me.callParent();

    me.down('nx-settingsform').getDockedItems('toolbar[dock="bottom"]')[0].add({
      xtype: 'button', text: NX.I18n.get('Crowd_CrowdSettings_VerifyConnection_Text'), formBind: true, action: 'verify'
    });
  }

});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * CLM settings form.
 *
 * @since 3.0
 */
Ext.define('NX.proui.view.clm.ClmSettings', {
  extend: 'NX.view.SettingsPanel',
  alias: 'widget.nx-proui-clm-settings',
  requires: [
    'NX.Conditions',
    'NX.I18n'
  ],

  /**
   * @override
   */
  initComponent: function () {
    var me = this;

    me.settingsForm = {
      xtype: 'nx-settingsform',
      settingsFormSuccessMessage: 'IQ Server Settings $action',
      api: {
        load: 'NX.direct.clm_CLM.read',
        submit: 'NX.direct.clm_CLM.update'
      },
      editableCondition: NX.Conditions.isPermitted('nexus:settings:update'),
      editableMarker: NX.I18n.get('Clm_ClmSettings_Permission_Error'),
      items: [
        {
          xtype: 'label',
          html: NX.I18n.get('ClmSettings_Html')
        },
        {
          xtype: 'checkbox',
          name: 'enabled',
          fieldLabel: NX.I18n.get('ClmSettings_Enable_FieldLabel'),
          helpText: NX.I18n.get('ClmSettings_Enable_HelpText')
        },
        {
          xtype: 'nx-url',
          name: 'url',
          fieldLabel: NX.I18n.get('ClmSettings_URL_FieldLabel'),
          helpText: NX.I18n.get('ClmSettings_URL_HelpText'),
          emptyText: NX.I18n.get('ClmSettings_URL_EmptyText')
        },
        {
          name: 'username',
          fieldLabel: NX.I18n.get('ClmSettings_Username_FieldLabel'),
          helpText: NX.I18n.get('ClmSettings_Username_HelpText'),
          emptyText: NX.I18n.get('ClmSettings_Username_EmptyText')
        },
        {
          xtype: 'nx-password',
          name: 'password',
          fieldLabel: NX.I18n.get('ClmSettings_Password_FieldLabel'),
          helpText: NX.I18n.get('ClmSettings_Password_HelpText'),
          emptyText: NX.I18n.get('ClmSettings_Password_EmptyText')
        },
        {
          xtype: 'numberfield',
          name: 'timeout',
          fieldLabel: NX.I18n.get('ClmSettings_ConnectionTimeout_FieldLabel'),
          helpText: NX.I18n.get('ClmSettings_ConnectionTimeout_HelpText'),
          emptyText: NX.I18n.get('ClmSettings_ConnectionTimeout_EmptyText'),
          allowBlank: true,
          allowDecimals: false,
          allowExponential: false,
          minValue: 1,
          maxValue: 3600
        },
        {
          xtype: 'textareafield',
          name: 'properties',
          fieldLabel: NX.I18n.get('ClmSettings_Properties_FieldLabel'),
          helpText: NX.I18n.get('ClmSettings_Properties_HelpText'),
          emptyText: NX.I18n.get('ClmSettings_Properties_EmptyText'),
          allowBlank: true
        }
      ]
    };

    me.callParent();

    me.down('nx-settingsform').getDockedItems('toolbar[dock="bottom"]')[0].add({
      xtype: 'button', text: NX.I18n.get('ClmSettings_Properties_Verify_Button'), formBind: true, action: 'verify'
    });
  }

});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * CLM dashboard view.
 *
 * @since 3.0
 */
Ext.define('NX.proui.view.clm.ClmDashboard', {
  extend: 'Ext.panel.Panel',
  alias: 'widget.nx-proui-clm-dashboard',

  /**
   * @override
   */
  initComponent: function () {
    var me = this;

    me.items = [
      {
        xtype: 'box',
        html: '<p>Visit the <a href="http://www.sonatype.com/clm" target="_blank">IQ Server</a> dashboard to manage applications, organizations and policies.</p>',
        margin: 10
      },
      {
        xtype: 'nx-settingsform',
        buttons: [
          {
            xtype: 'button',
            action: 'open',
            ui: 'nx-primary',
            text: 'Open IQ Server Dashboard',
            glyph: 'xf08e@FontAwesome' /* fa-external-link */
          }
        ]
      }
    ];

    me.callParent();
  }
});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * CLM Application store.
 *
 * @since 3.0
 */
Ext.define('NX.proui.store.ClmApplication', {
  extend: 'Ext.data.Store',
  model: 'NX.coreui.model.Reference',

  proxy: {
    type: 'direct',
    paramsAsHash: false,

    api: {
      read: 'NX.direct.clm_CLM.readApplications'
    },

    reader: {
      type: 'json',
      root: 'data',
      idProperty: 'id',
      successProperty: 'success'
    }
  },

  sorters: { property: 'name', direction: 'ASC' }
});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * CLM test results window (shows a list of applications).
 *
 * @since 3.0
 */
Ext.define('NX.proui.view.clm.ClmSettingsTestResults', {
  extend: 'NX.view.ModalDialog',
  alias: 'widget.nx-proui-clm-settings-testresults',
  requires: [
    'Ext.data.JsonStore',
    'NX.I18n'
  ],

  /**
   * @cfg json array of applications (as returned by checking the connection)
   */
  applications: undefined,

  /**
   * @override
   */
  initComponent: function () {
    var me = this;

    me.title = NX.I18n.get('Clm_SettingsTestResults_Title');

    me.layout = 'fit';
    me.closable = true;
    me.autoShow = true;
    me.modal = true;
    me.constrain = true;

    me.buttonAlign = 'left';
    me.buttons = [
      { text: NX.I18n.get('Button_Close'), handler: function () {
        this.up('window').close();
      }}
    ];

    me.items = {
      xtype: 'grid',
      emptyText: NX.I18n.get('Clm_SettingsTestResults_EmptyText'),
      columns: [
        { header: NX.I18n.get('Clm_SettingsTestResults_Id_Header'), dataIndex: 'id', flex: 1 },
        { header: NX.I18n.get('Clm_SettingsTestResults_Name_Header'), dataIndex: 'name', flex: 1 }
      ],
      store: Ext.create('Ext.data.JsonStore', {
        fields: ['id', 'name'],
        data: me.applications
      })
    };

    me.width = NX.view.ModalDialog.LARGE_MODAL;
    me.maxHeight = me.height = Ext.getBody().getViewSize().height - 100;

    me.callParent();
    me.center();
  }

});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * CLM controller.
 *
 * @since 3.0
 */
Ext.define('NX.proui.controller.Clm', {
  extend: 'NX.app.Controller',
  requires: [
    'NX.State',
    'NX.Messages',
    'NX.Permissions',
    'NX.Windows',
    'NX.I18n'
  ],

  stores: [
    'ClmApplication'
  ],
  views: [
    'clm.ClmSettings',
    'clm.ClmDashboard',
    'clm.ClmSettingsTestResults'
  ],
  refs: [
    {
      ref: 'clmSettingsForm',
      selector: 'nx-proui-clm-settings'
    }
  ],

  /**
   * @override
   */
  init: function () {
    var me = this;

    // preload icon to avoid a grey icon when clm dashboard feature will be registered
    me.getApplication().getIconController().addIcons({
      'feature-clm-dashboard': {
        file: 'clm_dashboard.png',
        variants: ['x16', 'x32']
      }
    });

    me.getApplication().getFeaturesController().registerFeature({
      mode: 'admin',
      path: '/CLM/Server',
      text: NX.I18n.get('Clm_Text'),
      description: NX.I18n.get('Clm_Description'),
      view: { xtype: 'nx-proui-clm-settings' },
      iconConfig: {
        file: 'clm_server.png',
        variants: ['x16', 'x32']
      },
      visible: function () {
        return NX.Permissions.check('nexus:settings:read');
      }
    }, me);

    me.onClmStateChanged(NX.State.getValue('clm'), undefined, true);

    me.listen({
      controller: {
        '#State': {
          clmchanged: me.onClmStateChanged
        }
      },
      component: {
        'nx-proui-clm-settings button[action=verify]': {
          click: me.verifyConnection
        },
        'nx-proui-clm-settings nx-settingsform': {
          submitted: me.onSubmitted
        },
        'nx-proui-clm-dashboard': {
          activate: me.openDashboardWindow
        },
        'nx-proui-clm-dashboard button[action=open]': {
          click: me.openDashboardWindow
        }
      }
    });
  },

  /**
   * Verify the connection to the IQ Server.
   * @private
   */
  verifyConnection: function (button) {
    var form = button.up('form'),
        values = form.getForm().getFieldValues();

    form.getEl().mask('Checking connection to ' + values.url);

    NX.direct.clm_CLM.verifyConnection(values['url'], values['useTrustStoreForUrl'], values['timeout'], function (response) {
      form.getEl().unmask();
      if (Ext.isDefined(response) && response.success) {
        NX.Messages.add({ text: NX.I18n.format('Clm_Connection_Success', values.url), type: 'success' });
        Ext.widget('nx-proui-clm-settings-testresults', {applications: response.data});
      }
    });
  },

  /**
   * @private
   */
  onSubmitted: function(form, action) {
    NX.State.setValue('clm', Ext.apply(Ext.clone(NX.State.getValue('clm', {})), {
      enabled: action.result.data.enabled,
      url: action.result.data.url
    }));
  },

  /**
   * Update the global UI state to register/unregister this Feature.
   * @param newState
   * @param oldState
   * @param avoidMenuRefresh
   * @private
   */
  onClmStateChanged: function (newState, oldState, avoidMenuRefresh) {
    var me = this,
        features = me.getApplication().getFeaturesController(),
        shouldRefreshMenu = false;

    if (oldState && oldState.enabled && oldState.url) {
      features.unregisterFeature({
        mode: 'admin',
        path: '/CLM/Dashboard'
      });
      shouldRefreshMenu = true;
    }
    if (newState && newState.enabled && newState.url) {
      features.registerFeature({
        mode: 'admin',
        path: '/CLM/Dashboard',
        text: NX.I18n.get('Clm_Dashboard_Title'),
        description: NX.I18n.get('Clm_Dashboard_Description'),
        view: { xtype: 'nx-proui-clm-dashboard' },
        weight: 10,
        // use preloaded icon to avoid a grey icon
        iconName: 'feature-clm-dashboard',
        visible: function () {
          var clmState = NX.State.getValue('clm');
          return NX.Permissions.check('nexus:settings:read') && clmState && clmState.enabled && clmState.url;
        }
      }, me);
      shouldRefreshMenu = true;
    }
    if (!avoidMenuRefresh && shouldRefreshMenu) {
      me.getController('Menu').refreshMenu();
    }
  },

  /**
   * @private
   */
  openDashboardWindow: function() {
    var state = NX.State.getValue('clm');

    NX.Windows.open(state.url);
  },

  /**
   * Load the list of applications available from the configured server and show it in a modal window.
   * @private
   */
  loadApplications: function () {
    this.getClmClmApplicationsView().create().show();
  }

});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * License User model.
 *
 * @since 3.0
 */
Ext.define('NX.proui.model.LicenseUser', {
  extend: 'Ext.data.Model',
  fields: [
    {name: 'ip', type: 'string', sortType: 'asUCText'},
    {name: 'userId', type: 'string', sortType: 'asUCText'},
    {name: 'userAgent', type: 'string', sortType: 'asUCText'},
    {name: 'timestamp', type: 'date', dateFormat: 'c'}
  ]
});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * License User store.
 *
 * @since 3.0
 */
Ext.define('NX.proui.store.LicenseUser', {
  extend: 'Ext.data.Store',
  model: 'NX.proui.model.LicenseUser',

  proxy: {
    type: 'direct',
    paramsAsHash: false,

    api: {
      read: 'NX.direct.licensing_Licensing.readLicenseUsers'
    },

    reader: {
      type: 'json',
      root: 'data',
      successProperty: 'success'
    }
  },

  sorters: { property: 'ip', direction: 'ASC' }
});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * License User grid.
 *
 * @since 3.0
 */
Ext.define('NX.proui.view.licensing.LicenseUserList', {
  extend: 'Ext.grid.Panel',
  alias: 'widget.nx-proui-licensing-licenseuser-list',
  requires: [
    'NX.I18n'
  ],

  stateful: true,
  stateId: 'nx-proui-licensing-licenseuser-list',

  /**
   * @override
   */
  initComponent: function() {
    Ext.apply(this, {
      store: 'LicenseUser',

      columns: [
        {
          xtype: 'nx-iconcolumn',
          width: 36,
          iconVariant: 'x16',
          iconName: function () {
            return 'licenseuser-default';
          }
        },
        { header: NX.I18n.get('Licensing_LicenseUserList_IP_Header'), dataIndex: 'ip', stateId: 'ip', flex: 1 },
        { header: NX.I18n.get('Licensing_LicenseUserList_Date_Header'), dataIndex: 'timestamp', stateId: 'timestamp', flex: 1 },
        { header: NX.I18n.get('Licensing_LicenseUserList_User_Header'), dataIndex: 'userId', stateId: 'userId', flex: 1 },
        { header: NX.I18n.get('Licensing_LicenseUserList_Agent_Header'), dataIndex: 'userAgent', stateId: 'userAgent', flex: 2 }
      ],

      viewConfig: {
        emptyText: NX.I18n.get('Licensing_LicenseUserList_EmptyText'),
        deferEmptyText: false
      },

      dockedItems: [{
        xtype: 'nx-actions',
        items: {
          xtype: 'button',
          text: NX.I18n.get('Licensing_LicenseUserList_Download_Button'),
          glyph: 'xf019@FontAwesome' /* fa-download */,
          action: 'download'
        }
      }],

      plugins: [{ ptype: 'gridfilterbox', emptyText: 'No license user matched criteria "$filter"' }]
    });

    this.callParent();
  }

});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * License Users controller.
 *
 * @since 3.0
 */
Ext.define('NX.proui.controller.LicenseUsers', {
  extend: 'NX.app.Controller',
  requires: [
    'NX.Permissions',
    'NX.util.DownloadHelper',
    'NX.util.Url',
    'NX.I18n'
  ],

  stores: [
    'LicenseUser'
  ],
  views: [
    'licensing.LicenseUserList'
  ],
  refs: [
    {
      ref: 'list',
      selector: 'nx-proui-licensing-licenseuser-list'
    }
  ],

  /**
   * @override
   */
  init: function () {
    var me = this;

    me.getApplication().getIconController().addIcons({
      'licenseuser-default': {
        file: 'ssl_certificates.png',
        variants: ['x16', 'x32']
      }
    });

    me.getApplication().getFeaturesController().registerFeature({
      mode: 'admin',
      path: '/System/Licensing/License Users',
      text: NX.I18n.get('LicenseUsers_Title'),
      description: NX.I18n.get('LicenseUsers_Description'),
      view: { xtype: 'nx-proui-licensing-licenseuser-list' },
      iconConfig: {
        file: 'ssl_tls_manager.png',
        variants: ['x16', 'x32']
      },
      visible: function () {
        return NX.Permissions.check('nexus:licensing:read');
      }
    }, me);

    me.listen({
      controller: {
        '#Refresh': {
          refresh: me.load
        }
      },
      component: {
        'nx-proui-licensing-licenseuser-list': {
          afterrender: me.load
        },
        'nx-proui-licensing-licenseuser-list button[action=download]': {
          click: me.download
        }
      }
    });
  },

  /**
   * @private
   * Load active user store.
   */
  load: function () {
    var list = this.getList();

    if (list) {
      list.getStore().load();
    }
  },

  /**
   * @private
   * Download active users in CSV format.
   */
  download: function () {
    NX.util.DownloadHelper.downloadUrl(NX.util.Url.urlOf('service/siesta/licensing/csv_access_data'));
  }

});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * Node model.
 *
 * @since 3.0
 */
Ext.define('NX.proui.model.Node', {
  extend: 'Ext.data.Model',
  idProperty: 'uuid',
  fields: [
    { name: 'uuid', type: 'string' },
    { name: 'local', type: 'bool' },
    { name: 'socketAddress', type: 'string' },
    { name: 'attributes', type: 'auto' /*object*/}
  ]
});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * Node store.
 *
 * @since 3.0
 */
Ext.define('NX.proui.store.Node', {
  extend: 'Ext.data.Store',
  model: 'NX.proui.model.Node',

  proxy: {
    type: 'direct',
    paramsAsHash: false,
    api: {
      read: 'NX.direct.proui_Node.read'
    },

    reader: {
      type: 'json',
      root: 'data',
      idProperty: 'uuid',
      successProperty: 'success'
    }
  },

  sorters: { property: 'local', direction: 'ASC' }

});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * Health Check info panel.
 *
 * @since 3.0
 */
Ext.define('NX.proui.view.healthcheck.HealthCheckAssetDetail', {
  extend: 'Ext.panel.Panel',
  alias: 'widget.nx-proui-healthcheck-healthcheckassetdetail',
  requires: [
    'NX.util.Base64',
    'NX.util.Url',
    'NX.Windows',
    'NX.I18n'
  ],
  ui: 'nx-inset',

  layout: 'fit',

  /**
   * Name of repository containing asset to be shown.
   * @private
   */
  repositoryName: undefined,

  /**
   * Format of asset to be shown.
   * @private
   */
  format: undefined,

  /**
   * Path of asset to be shown.
   * @private
   */
  path: undefined,

  /**
   * @private
   * True if info was successfully loaded from server.
   */
  loaded: false,

  /**
   * @private
   * True when active in toolbar.
   */
  active: false,

  listeners: {
    afterrender: function() {
      var me = this;
      me.active = true;
      me.loadInfo();
    }
  },

  /**

   * Shows Health Check information about selected file.
   *
   * @public
   * @param {NX.coreui.model.Asset} assetModel selected asset
   */
  showInfo: function(assetModel) {
    var me = this;
    me.format = assetModel.get('format');
    me.repositoryName = assetModel.get('repositoryName');
    me.path = assetModel.get('name');
    me.loaded = false;
    me.loadInfo();
  },

  /**
   * @private
   * Loads Health Check information about selected file.
   */
  loadInfo: function() {
    var me = this;

    if (!me.loaded) {
      me.removeAll();
      if (me.active && me.rendered) {
        var loadMask = new Ext.LoadMask( {
          msg: NX.I18n.get('HealthCheckInfo_Loading_Text'),
          target: me
        });
        loadMask.show();
        if (me.path) {
          me.add([
            {
              xtype: 'panel',
              ui: 'nx-subsection',
              frame: true,

              items: [
                {
                  xtype: 'box',
                  border: false,
                  autoEl: {
                    tag: 'iframe',
                    src: NX.util.Url.urlOf('service/siesta/healthcheck/healthCheckFileDetail/'
                        + NX.util.Base64.encode(me.path) + '/index.html?' +
                        Ext.Object.toQueryString({
                          format: me.format,
                          repositoryName: me.repositoryName
                        })
                    ),
                    width: '100%',
                    height: '100%',
                    scrolling: 'auto'
                  },
                  listeners: {
                    afterrender: function(iframe) {
                      me.loaded = true;
                      Ext.EventManager.on(iframe.getEl().dom, 'load', function() {
                        var insight = iframe.getEl().dom.contentWindow.Insight;
                        loadMask.hide();
                        loadMask.destroy();
                        if (insight) {
                          me.setClmComponent(insight);
                          me.registerClmViewDetailsListener(insight);
                        }
                      });
                    }
                  }
                }
              ]
            }
          ]);
        }
      }
    }
  },

  /**
   * @private
   */
  setClmComponent: function(insight) {
    var me = this;

    NX.direct.healthcheck_AssetDetail.identify(me.repositoryName, me.path, function(response) {
      if (Ext.isObject(response)) {
        if (response.success) {
          var format = response.data.componentIdentifier.format,
              coordinates = response.data.componentIdentifier.coordinates,
              hash = response.data.hash;

          if (me.isLegacyClm(insight)) {
            me.setLegacyClmComponent(insight, format, coordinates, hash);
          }
          else {
            insight.setCoordinates(format, coordinates, {hash: hash});
          }
        }
        else {
          insight.setError({
            errorMessage: 'Unable to identify component: ' + response.message,
            errorCode: 400
          });
        }
      }
      else {
        insight.setError({
          errorMessage: 'Unable to identify component',
          errorCode: 500
        });
      }
    });
  },

  /**
   * @private
   */
  setLegacyClmComponent: function(insight, format, coordinates, hash) {
    if (format !== 'maven') {
      insight.setError({
        errorMessage: 'Unsupported repository format, please upgrade to Nexus IQ Server 1.13 or greater.',
        errorCode: 400
      });
      return;
    }

    insight.setGav({
      groupId: coordinates.groupId,
      artifactId: coordinates.artifactId,
      version: coordinates.version,
      extension: coordinates.extension,
      classifier: coordinates.classifier,
      hash: hash
    });
  },

  /**
   * @private
   */
  registerClmViewDetailsListener: function(insight) {
    var me = this;
    if (!me.isLegacyClm(insight)) {
      me.registerLegacyClmViewDetailsListener(insight);
    }
    else {
      insight.registerViewDetailsListener(
          function(appId, format, coordinates, hash) {
            var component = {
                  format: format,
                  coordinates: {}
                },
                queryParams = {
                  appId: appId,
                  hash: hash
                };

            if (coordinates) {
              for (var i = 0; i < coordinates.length; i += 2) {
                component.coordinates[coordinates[i]] = coordinates[i + 1];
              }
            }
            queryParams['componentIdentifier'] = JSON.stringify(component);

            if (coordinates) {
              NX.Windows.open(
                  NX.util.Url.urlOf(
                      'service/siesta/healthcheck/clm/assets/version-graph/rm/nexus/viewdetails.html?' +
                      Ext.Object.toQueryString(queryParams)
                  )
              );
            }
          }
      );
    }
  },

  registerLegacyClmViewDetailsListener: function(insight) {
    insight.registerViewDetailsListener(
        function(appId, groupId, artifactId, version, classifier, extension, hash) {
          var queryParams = {
            appId: appId,
            hash: hash,
            groupId: groupId,
            artifactId: artifactId,
            version: version,
            classifier: classifier,
            extension: extension
          };

          NX.Windows.open(
              NX.util.Url.urlOf(
                  'service/siesta/healthcheck/clm/assets/version-graph/rm/nexus/viewdetails.html?' +
                  Ext.Object.toQueryString(queryParams)
              )
          );
        });
  },

  showDetails: function(appId, hash, component, legacy) {
    Sonatype.view.mainTabPanel.addOrShowTab(me.toTabId(appId, hash, component, legacy),
        Nexus.clm.ComponentDetailView, {
          title: 'IQ Server Detail',
          appId: appId,
          hash: hash,
          component: !legacy ? component : null,
          gav: legacy ? component.coordinates : null
        });
  },

  /**
   * @private
   */
  isLegacyClm: function(insight) {
    return !(insight.registerCoordsViewDetailsListener || insight.setCoordinates);
  }

});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * Nodes feature panel.
 *
 * @since 3.0
 */
Ext.define('NX.proui.view.system.Nodes', {
  extend: 'NX.view.drilldown.Drilldown',
  alias: 'widget.nx-proui-system-nodes',
  requires: [
    'NX.I18n'
  ],

  /**
   * @override
   */
  initComponent: function() {
    Ext.apply(this, {
      iconName: 'node-default',

      masters: [
        { xtype: 'nx-proui-system-nodelist' }
      ],

      tabs: {
        xtype: 'nx-info-panel',
        title: NX.I18n.get('System_Bundles_Details_Tab')
      }
    });

    this.callParent();
  }
});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * Node list.
 *
 * @since 3.0
 */
Ext.define('NX.proui.view.system.NodeList', {
  extend: 'NX.view.drilldown.Master',
  alias: 'widget.nx-proui-system-nodelist',
  requires: [
    'NX.I18n'
  ],

  config: {
    stateful: true,
    stateId: 'nx-proui-system-nodelist'
  },

  store: 'Node',

  columns: [
    {
      xtype: 'nx-iconcolumn',
      width: 36,
      iconVariant: 'x16',
      iconName: function () {
        return 'node-default';
      }
    },
    {
      header: 'UUID',
      dataIndex: 'uuid',
      stateId: 'uuid',
      flex: 1
    },
    {
      header: 'Local',
      dataIndex: 'local',
      stateId: 'local',
      width: 80
    },
    {
      header: 'Socket Address',
      dataIndex: 'socketAddress',
      stateId: 'socketAddress',
      flex: 1
    }
  ],

  plugins: [
    {ptype: 'gridfilterbox', emptyText: 'No nodes matched "$filter"'}
  ]
});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * Nodes controller.
 *
 * @since 3.0
 */
Ext.define('NX.proui.controller.Nodes', {
  extend: 'NX.controller.Drilldown',
  requires: [
    'NX.view.info.Panel',
    'NX.view.info.Entry',
    'NX.util.Url',
    'NX.Permissions',
    'NX.I18n'
  ],
  masters: [
    'nx-proui-system-nodelist'
  ],
  stores: [
    'Node'
  ],
  views: [
    'system.Nodes',
    'system.NodeList'
  ],
  refs: [
    { ref: 'feature', selector: 'nx-proui-system-nodes' },
    { ref: 'list', selector: 'nx-proui-system-nodelist' },
    { ref: 'info', selector: 'nx-proui-system-nodes nx-info-panel' }
  ],

  features: {
    mode: 'admin',
    path: '/System/Nodes',
    text: 'Nodes',
    description: 'View nodes',
    view: 'NX.proui.view.system.Nodes',
    iconConfig: {
      file: 'servers_network.png',
      variants: ['x16', 'x32']
    },
    visible: function () {
      return NX.Permissions.check('nexus:nodes:read');
    }
  },

  icons: {
    'node-default': {
      file: 'server.png',
      variants: ['x16', 'x32']
    }
  },

  /**
   * @override
   */
  init: function() {
    var me = this;

    me.callParent();

    me.listen({
      controller: {
        '#Refresh': {
          refresh: me.loadStores
        }
      },
      store: {
        '#Node': {
          load: me.reselect
        }
      }
    });
  },

  /**
   * @override
   */
  getDescription: function (model) {
    return model.get('uuid');
  },

  onSelection: function (list, model) {
    var me = this,
        info,
        attributes;

    if (Ext.isDefined(model)) {
      info = {};
      info['UUID'] = model.get('uuid');
      info['Local'] = model.get('local');
      info['Socket Address'] = model.get('socketAddress');

      attributes = model.get('attributes');
      if (attributes) {
        Ext.iterate(attributes, function (key, value) {
          info[key] = value;
        });
      }

      me.getInfo().showInfo(info);
    }
  }
});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * HealthCheck repository detail controller.
 *
 * Adds a detail button to health check summary window shown when hovering over enabled repositories in repository grid.
 *
 * @since 3.0
 */
Ext.define('NX.proui.controller.HealthCheckRepositoryDetail', {
  extend: 'NX.app.Controller',
  requires: [
    'NX.Permissions',
    'NX.Windows'
  ],

  /**
   * @override
   */
  init: function() {
    var me = this;

    me.listen({
      component: {
        'nx-coreui-healthcheck-summary': {
          afterrender: me.addDetailButton
        },
        'nx-coreui-healthcheck-summary button[action=viewdetail]': {
          click: me.viewDetail
        }
      }
    });
  },

  /**
   * Add 'View Detailed Report' to Summary tooltip window.
   *
   * @private
   * @param {NX.coreui.view.healthcheck.HealthCheckSummary} win summary window
   */
  addDetailButton: function(win) {
    var statusModel = win['statusModel'],
        toolbar;

    if (statusModel && statusModel.get('detailedReportSupported')) {
      if (!win.getDockedItems('toolbar[dock="bottom"]').length) {
        win.addDocked({ xtype: 'toolbar', dock: 'bottom', items: [] });
      }
      toolbar = win.getDockedItems('toolbar[dock="bottom"]')[0];
      if (statusModel.get('detailUrl')) {
        toolbar.add([
          '->',
          {
            xtype: 'button', text: 'View Detailed Report', action: 'viewdetail',
            disabled: !NX.Permissions.check('nexus:healthcheckdetail:read')
          }
        ]);
      }
      else {
        toolbar.add([
          '->',
          'The next analysis will include the detailed report.'
        ]);
      }
    }
  },

  /**
   * Show detail report into a new browser tab/window.
   *
   * @private
   * @param {Ext.Button} button 'View Detailed Report' button
   */
  viewDetail: function(button) {
    var win = button.up('window'),
        statusModel = win['statusModel'];

    NX.Windows.open(statusModel.get('detailUrl'));
    win.close();
  }

});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * Licensing details panel.
 *
 * @since 3.0
 */
Ext.define('NX.proui.view.licensing.LicensingDetails', {
  extend: 'NX.view.SettingsPanel',
  alias: 'widget.nx-proui-licensing-details',
  requires: [
    'NX.I18n'
  ],

  /**
   * @override
   */
  initComponent: function() {
    Ext.apply(this, {
      settingsForm: [
        {
          xtype: 'nx-settingsform',
          api: {
            load: 'NX.direct.licensing_Licensing.read'
          },
          itemId: 'details',
          defaults: {
            xtype: 'textfield',
            readOnly: true
          },
          items: [
            { name: 'contactCompany', fieldLabel: NX.I18n.get('Licensing_LicensingDetails_Company_FieldLabel') },
            { name: 'contactName', fieldLabel: NX.I18n.get('Licensing_LicensingDetails_Name_FieldLabel') },
            { name: 'contactEmail', fieldLabel: NX.I18n.get('Licensing_LicensingDetails_Email_FieldLabel') },
            { name: 'effectiveDate', fieldLabel: NX.I18n.get('Licensing_LicensingDetails_EffectiveDate_FieldLabel'), xtype:'nx-datedisplayfield' },
            { name: 'expirationDate', fieldLabel: NX.I18n.get('Licensing_LicensingDetails_ExpirationDate_FieldLabel'), xtype:'nx-datedisplayfield' },
            { name: 'licenseType', fieldLabel: NX.I18n.get('Licensing_LicensingDetails_Type_FieldLabel') },
            { name: 'licensedConnections', fieldLabel: NX.I18n.get('Licensing_LicensingDetails_Connections_FieldLabel') }
          ],
          buttons: undefined
        },
        {
          xtype: 'form',
          title: NX.I18n.get('Licensing_LicensingDetails_InstallLicense_Title'),
          ui: 'nx-subsection',
          frame: true,

          api: {
            submit: 'NX.direct.licensing_Licensing.install'
          },

          items: [
            {
              xtype: 'label',
              html: NX.I18n.get('Licensing_LicensingDetails_InstallLicense_Html')
            },
            {
              xtype: 'fileuploadfield',
              name: 'license',
              allowBlank: false,
              buttonText: NX.I18n.get('Licensing_LicensingDetails_LicenseSelect_Button'),
              buttonConfig: {
                glyph: 'xf016@FontAwesome' /* fa-file-o */
              }
            }
          ],

          buttonAlign: 'left',
          buttons: [
            { text: NX.I18n.get('Licensing_LicensingDetails_LicenseInstall_Button'), action: 'install', formBind: true, ui: 'nx-primary', glyph: 'xf023@FontAwesome' /* fa-lock */ }
          ]
        },
        {
          xtype: 'form',
          title: NX.I18n.get('Licensing_LicensingDetails_LicenseUninstall_Title'),
          ui: 'nx-subsection',
          frame: true,

          items: [
            {
              xtype: 'label',
              html: NX.I18n.get('Licensing_LicensingDetails_LicenseUninstall_Html')
            }
          ],

          buttonAlign: 'left',
          buttons: [
            { text: NX.I18n.get('Licensing_LicensingDetails_LicenseUninstall_Button'), action: 'uninstall', ui: 'nx-primary', glyph: 'xf023@FontAwesome' /* fa-lock */ }
          ]
        }
      ]
    });

    this.callParent();
  }

});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * Dialog to display a user's user-token details.
 *
 * @since 3.0
 */
Ext.define('NX.proui.view.usertoken.UserTokenDetails', {
  extend: 'Ext.window.Window',
  alias: 'widget.nx-proui-usertoken-details',
  requires: [
    'NX.Icons',
    'NX.Messages',
    'NX.I18n'
  ],

  /**
   * user token userCode.
   *
   * @cfg {String}
   */
  nameCode: undefined,

  /**
   * user token passCode.
   *
   * @cfg {String}
   */
  passCode: undefined,

  /**
   * @override
   */
  initComponent: function () {
    var me = this;

    me.title = NX.I18n.get('UserToken_UserTokenDetails_Title');
    me.autoShow = true;
    me.modal = true;
    me.constrain = true;
    me.width = 640;
    me.resizable = false;

    me.items = {
      xtype: 'form',
      bodyPadding: 10,
      items: [
        {
          xtype: 'panel',
          layout: 'hbox',
          items: [
            { xtype: 'component', html: NX.Icons.img('usertoken-default', 'x32') },
            { xtype: 'label', margin: '0 0 0 5',
              html: NX.I18n.get('UserToken_UserTokenDetails_Html1')
            }
          ]
        },
        {
          xtype: 'label',
          html: NX.I18n.get('UserToken_UserTokenDetails_Html2')
        },
        {
          xtype: 'panel',
          layout: 'hbox',
          items: [
            {
              xtype: 'textfield',
              name: 'nameCode',
              value: me.nameCode,
              width: 100,
              readOnly: true,
              selectOnFocus: true,
              fieldCls: 'user-token-field'
            },
            {
              xtype: 'label',
              html: ':',
              cls: 'nx-user-token-field'
            },
            {
              xtype: 'textfield',
              name: 'passCode',
              value: me.passCode,
              width: 360,
              readOnly: true,
              selectOnFocus: true,
              fieldCls: 'user-token-field'
            }
          ]
        },
        {
          xtype: 'label',
          html: NX.I18n.get('UserToken_UserTokenDetails_Html3')
        },
        {
          xtype: 'textarea',
          value: '<server>\n' +
              '  <id>${server}</id>\n' +
              '  <username>' + me.nameCode + '</username>\n' +
              '  <password>' + me.passCode + '</password>\n' +
              '</server>',
          height: 90,
          width: 610,
          readOnly: true,
          selectOnFocus: true,
          fieldCls: 'user-token-field'
        },
        {
          xtype: 'label',
          html: NX.I18n.get('UserToken_UserTokenDetails_AutoClose_Html')
        }
      ],
      buttonAlign: 'left',
      buttons: [
        { text: NX.I18n.get('Button_Close'), ui: 'nx-primary', handler: function () {
          this.up('window').close();
        }}
      ]
    };

    me.callParent();

    // Automatically close the window
    Ext.defer(function () {
      // ignore if already closed
      if (me.isVisible()) {
        NX.Messages.add({ text: NX.I18n.get('UserToken_UserTokenDetails_AutoClosing_Message') });
        me.close();
      }
      // 1 minute
    }, 1 * 60 * 1000);
  }

});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * Crowd controller.
 *
 * @since 3.0
 */
Ext.define('NX.proui.controller.Crowd', {
  extend: 'NX.app.Controller',
  requires: [
    'NX.Permissions',
    'NX.Messages',
    'NX.I18n'
  ],

  views: [
    'crowd.CrowdSettings'
  ],

  /**
   * @override
   */
  init: function () {
    var me = this;

    me.getApplication().getIconController().addIcons({
      'crowd-security-source': {
        file: 'crowd.png',
        variants: ['x16']
      }
    });

    me.getApplication().getFeaturesController().registerFeature({
      mode: 'admin',
      path: '/Security/Atlassian Crowd',
      text: NX.I18n.get('Crowd_Text'),
      description: NX.I18n.get('Crowd_Description'),
      view: { xtype: 'nx-proui-crowd-settings' },
      iconConfig: {
        file: 'crowd.png',
        variants: ['x16', 'x32']
      },
      visible: function () {
        return NX.Permissions.check('nexus:crowd:read');
      }
    }, me);

    me.listen({
      component: {
        'nx-proui-crowd-settings button[action=verify]': {
          click: me.verifyConnection
        }
      }
    });
  },

  verifyConnection: function (button) {
    var form = button.up('form'),
        values = form.getForm().getFieldValues();

    form.getEl().mask('Checking connection to ' + values.url);

    NX.direct.crowd_Crowd.verifyConnection(values, function (response) {
      form.getEl().unmask();
      if (Ext.isDefined(response) && response.success) {
        NX.Messages.add({ text: NX.I18n.format('Crowd_CrowdSettings_Verified_Success', values.url), type: 'success' });
      }
    });
  }

});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * Usertoken settings form.
 *
 * @since 3.0
 */
Ext.define('NX.proui.view.usertoken.UserTokenSettings', {
  extend: 'NX.view.SettingsPanel',
  alias: 'widget.nx-proui-usertoken-settings',
  requires: [
    'NX.Conditions',
    'NX.I18n'
  ],

  /**
   * @override
   */
  initComponent: function() {
    Ext.apply(this, {
      settingsForm: [
        {
          xtype: 'nx-settingsform',
          settingsFormSuccessMessage: NX.I18n.get('UserTokenSettings_Update_Success'),
          api: {
            load: 'NX.direct.usertoken_UserToken.read',
            submit: 'NX.direct.usertoken_UserToken.update'
          },
          editableCondition: NX.Conditions.isPermitted('nexus:usertoken:settings:update'),
          editableMarker: NX.I18n.get('UserTokenSettings_Update_Error'),

          items: [
            {
              xtype: 'label',
              html: NX.I18n.get('UserTokenSettings_Html')
            },
            {
              xtype: 'checkbox',
              name: 'enabled',
              fieldLabel: NX.I18n.get('UserTokenSettings_Enable_FieldLabel')
            },
            {
              xtype: 'checkbox',
              name: 'protectContent',
              fieldLabel: NX.I18n.get('UserTokenSettings_Require_FieldLabel'),
              helpText: NX.I18n.get('UserTokenSettings_Require_HelpText')
            }
          ]
        },
        {
          xtype: 'form',
          ui: 'nx-subsection',
          frame: true,
          itemId: 'resetAll',
          title: NX.I18n.get('UserTokenSettings_Reset_Title'),
          hidden: true,

          items: [
            {
              xtype: 'label',
              html: NX.I18n.get('UserTokenSettings_Reset_Html')
            }
          ],

          buttonAlign: 'left',
          buttons: [
            { text: NX.I18n.get('UserTokenSettings_ResetAll_Button'), action: 'resetall', ui: 'nx-primary', glyph: 'xf023@FontAwesome' /* fa-lock */ }
          ]
        }
      ]
    });

    this.callParent();
  }

});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * User Token controller.
 *
 * @since 3.0
 */
Ext.define('NX.proui.controller.UserToken', {
  extend: 'NX.app.Controller',
  requires: [
    'NX.Conditions',
    'NX.Messages',
    'NX.Permissions',
    'NX.Security',
    'NX.State',
    'NX.I18n'
  ],

  views: [
    'usertoken.UserTokenCurrent',
    'usertoken.UserTokenDetails',
    'usertoken.UserTokenSettings',
    'usertoken.UserTokenUser'
  ],
  refs: [
    {
      ref: 'userFeature',
      selector: 'nx-coreui-user-feature'
    },
    {
      ref: 'userUserTokenPanel',
      selector: 'nx-coreui-user-feature nx-proui-usertoken-user'
    }
  ],

  /**
   * @override
   */
  init: function () {
    var me = this;

    me.getApplication().getIconController().addIcons({
      'feature-usertoken': {
        file: 'key.png',
        variants: ['x16', 'x32']
      },
      'usertoken-default': {
        file: 'key.png',
        variants: ['x16', 'x32']
      }
    });

    me.getApplication().getFeaturesController().registerFeature([
      {
        mode: 'admin',
        path: '/Security/User Token',
        view: { xtype: 'nx-proui-usertoken-settings' },
        text: NX.I18n.get('UserToken_Text'),
        description: NX.I18n.get('UserToken_Description'),
        iconConfig: {
          file: 'key.png',
          variants: ['x16', 'x32']
        },
        visible: function () {
          return NX.Permissions.check('nexus:usertoken:settings:read');
        }
      },
      {
        mode: 'user',
        path: '/User Token',
        text: NX.I18n.get('UserToken_Text'),
        description: NX.I18n.get('UserToken_Description'),
        view: { xtype: 'nx-proui-usertoken-current' },
        iconConfig: {
          file: 'key.png',
          variants: ['x16', 'x32']
        },
        visible: function () {
          var userTokenState = NX.State.getValue('usertoken');
          return NX.Permissions.check('nexus:usertoken:current:read') && userTokenState && userTokenState.enabled;
        }
      }
    ], me);

    me.listen({
      component: {
        'nx-proui-usertoken-settings button[action=resetall]': {
          click: me.resetAll,
          afterrender: me.bindResetAllButton
        },
        'nx-proui-usertoken-settings nx-settingsform': {
          loaded: me.onLoaded,
          submitted: me.onSubmitted
        },
        'nx-proui-usertoken-current button[action=access]': {
          click: me.accessCurrent,
          afterrender: me.bindAccessButton
        },
        'nx-proui-usertoken-current button[action=reset]': {
          click: me.resetCurrent,
          afterrender: me.bindResetCurrentButton
        },
        'nx-coreui-user-list': {
          beforerender: me.bindUserUserTokenTab,
          selection: me.onUserSelection
        },
        'nx-proui-usertoken-user button[action=reset]': {
          click: me.reset,
          afterrender: me.bindResetButton
        }
      }
    });
  },

  /**
   * @private
   */
  onLoaded: function (form, action) {
    var resetAllForm = form.up('nx-proui-usertoken-settings').down('#resetAll');

    if (action.result.data.enabled) {
      resetAllForm.show();
    }
    else {
      resetAllForm.hide();
    }
  },

  /**
   * @private
   */
  onSubmitted: function (form, action) {
    NX.State.setValue('usertoken', Ext.apply(
        NX.State.getValue('usertoken', {}),
        { enabled: action.result.data.enabled }
    ));
  },

  /**
   * @private
   */
  onUserSelection: function (list, model) {
    var panel = this.getUserUserTokenPanel();

    if (Ext.isDefined(model) && panel) {
      panel.down('form').loadRecord(model);
    }
  },

  /**
   * @private
   * Show/Hide user token tab if user token is enabled.
   */
  bindUserUserTokenTab: function (list) {
    var me = this;
    list.mon(
        NX.Conditions.watchState('usertoken', function (userToken) {
          return userToken && userToken.enabled;
        }),
        {
          satisfied: function () {
            var panel = me.getUserUserTokenPanel();

            if (!panel) {
              me.getUserFeature().addTab({ xtype: 'nx-proui-usertoken-user' });
            }
          },
          unsatisfied: function () {
            var panel = me.getUserUserTokenPanel();

            if (panel) {
              panel.up('tabpanel').remove(panel);
            }
          },
          scope: me
        }
    );
  },

  /**
   * @override
   * @private
   * Enable 'Reset all user tokens' when user has 'nexus:usertoken:users:delete' permission.
   */
  bindResetAllButton: function (button) {
    button.mon(
        NX.Conditions.and(
            NX.Conditions.isPermitted('nexus:usertoken:users:delete')
        ),
        {
          satisfied: button.enable,
          unsatisfied: button.disable,
          scope: button
        }
    );
  },

  /**
   * @override
   * @private
   * Enable 'Access user token' when user has 'nexus:usertoken:current:read' permission.
   */
  bindAccessButton: function (button) {
    button.mon(
        NX.Conditions.and(
            NX.Conditions.isPermitted('nexus:usertoken:current:read')
        ),
        {
          satisfied: button.enable,
          unsatisfied: button.disable,
          scope: button
        }
    );
  },

  /**
   * @override
   * @private
   * Enable 'Reset user token' when user has 'nexus:usertoken:current:delete' permission.
   */
  bindResetCurrentButton: function (button) {
    button.mon(
        NX.Conditions.and(
            NX.Conditions.isPermitted('nexus:usertoken:current:delete')
        ),
        {
          satisfied: button.enable,
          unsatisfied: button.disable,
          scope: button
        }
    );
  },

  /**
   * @override
   * @private
   * Enable 'Reset user token' when user has 'nexus:usertoken:user:delete' permission.
   */
  bindResetButton: function (button) {
    button.mon(
        NX.Conditions.and(
            NX.Conditions.isPermitted('nexus:usertoken:user:delete')
        ),
        {
          satisfied: button.enable,
          unsatisfied: button.disable,
          scope: button
        }
    );
  },

  /**
   * @private
   */
  resetAll: function () {
    NX.Security.doWithAuthenticationToken(
        NX.I18n.format('UserToken_Authentication_Validation', 'Resetting'),
        {
          success: function (authToken) {
            NX.direct.usertoken_UserToken.resetAll(authToken, function (response) {
              if (Ext.isDefined(response) && response.success) {
                NX.Messages.add({ text: NX.I18n.get('UserToken_ResetAll_Success'), type: 'success' });
              }
            });
          }
        }
    );
  },

  /**
   * @private
   */
  accessCurrent: function () {
    NX.Security.doWithAuthenticationToken(
      NX.I18n.format('UserToken_Authentication_Validation', 'Accessing'),
        {
          success: function (authToken) {
            NX.direct.usertoken_UserToken.retrieveCurrent(authToken, function (response) {
              if (Ext.isDefined(response) && response.success) {
                Ext.widget('nx-proui-usertoken-details', response.data);
              }
            });
          }
        }
    );
  },

  /**
   * @private
   */
  resetCurrent: function () {
    NX.Security.doWithAuthenticationToken(
      NX.I18n.format('UserToken_Authentication_Validation', 'Resetting'),
        {
          success: function (authToken) {
            NX.direct.usertoken_UserToken.resetCurrent(authToken, function (response) {
              if (Ext.isDefined(response) && response.success) {
                NX.Messages.add({ text: NX.I18n.get('UserToken_Reset_Success'), type: 'success' });
              }
            });
          }
        }
    );
  },

  /**
   * @private
   */
  reset: function (button) {
    var form = button.up('form'),
        userModel = form.getRecord();
    NX.Security.doWithAuthenticationToken(
      NX.I18n.format('UserToken_Authentication_Validation', 'Resetting'),
        {
          success: function (authToken) {
            NX.direct.usertoken_UserToken.reset(authToken, userModel.getId(), function (response) {
              if (Ext.isDefined(response) && response.success) {
                NX.Messages.add({
                  text: NX.I18n.format('UserToken_ResetById_Message', userModel.getId()),
                  type: 'success'
                });
              }
            });
          }
        }
    );
  }

});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * Manages health check information (security and license alerts) shown in component details view.
 *
 * @since 3.0
 */
Ext.define('NX.proui.controller.HealthCheckInfo', {
  extend: 'NX.app.Controller',
  requires: [
    'NX.Conditions',
    'NX.Permissions',
    'NX.State',
    'NX.util.Url',
    'NX.I18n',
    'NX.coreui.util.HealthCheckUtil'
  ],

  /**
   * @override
   */
  init: function() {
    var me = this;

    me.listen({
      component: {
        'nx-coreui-component-details': {
          healthCheckLoaded: me.renderHealthCheckFields
        },
        'nx-coreui-component-details #healthCheckInfo': {
          afterrender: me.bindHealthCheckInfo
        }
      }
    });
  },

  /**
   * Add/Remove Health Check info section based on nexus:healthcheck:read permission.
   *
   * @private
   * @param {Ext.Panel} infoSection to add health check info section to
   */
  bindHealthCheckInfo: function(infoSection) {
    var me = this,
        panel = infoSection.up('nx-coreui-component-details');

    panel.mon(
        NX.Conditions.isPermitted("nexus:healthcheck:read"),
        {
          satisfied: Ext.pass(me.addHealthCheckInfo, panel),
          unsatisfied: Ext.pass(me.removeHealthCheckInfo, panel),
          scope: me
        }
    );
  },

  /**
   * Add Health Check info section to component details panel.
   *
   * @private
   * @param {Ext.Panel} panel to add health check info section to
   */
  addHealthCheckInfo: function(panel) {
    var infoPanel = panel.down('#healthCheckInfoPro');

    if (!infoPanel) {
      panel.add({
        xtype: 'nx-info',
        itemId: 'healthCheckInfoPro'
      });
    }
  },

  /**
   * Remove Health Check info section from component details panel.
   *
   * @private
   * @param {Ext.Panel} panel to remove health check info section from
   */
  removeHealthCheckInfo: function(panel) {
    var infoPanel = panel.down('#healthCheckInfoPro');

    if (infoPanel) {
      panel.remove(infoPanel);
    }
  },

  /**
   * Render healthcheck fields.
   *
   * @private
   * @param {Ext.Panel} panel containing health check info section
   * @param {NX.coreui.model.Component} model component model
   */
  renderHealthCheckFields: function(panel, model) {
    var me = this,
        infoPanel = panel.down('#healthCheckInfoPro'),
        info = {};

    if (infoPanel) {
      if (model) {
        info[NX.I18n.get('HealthCheckInfo_Security_Alerts_Label')] = me.renderSecurityAlerts(model);
        info[NX.I18n.get('HealthCheckInfo_License_Threat_Label')] = me.renderLicenseThreat(model);
      }
      infoPanel.showInfo(info);
    }
  },

  /**
   * Render security alerts column.
   *
   * @private
   * @param {NX.coreui.model.Component} model component model
   * @returns {String} rendered value
   */
  renderSecurityAlerts: function(model) {
    var me = this,
        metadata = {},
        result, securityAlerts, critical, severe, moderate,
        buildChiclet = function(clazz, value) {
          return '<span class="nx-clm-chiclet-small ' + clazz + '">' + value + '</span>';
        };

    result = me.renderPreconditions(model, metadata);
    if (!result) {
      securityAlerts = model.get('healthCheckSecurityAlerts');
      critical = model.get('healthCheckCriticalSecurityAlerts');
      severe = model.get('healthCheckSevereSecurityAlerts');
      moderate = model.get('healthCheckModerateSecurityAlerts');
      if (securityAlerts === 0 || securityAlerts > 0) {
        result = buildChiclet(critical > 0 ? 'critical' : '', critical > 0 ? critical : '')
            + buildChiclet(severe > 0 ? 'severe' : '', severe > 0 ? severe : '')
            + buildChiclet(moderate > 0 ? 'moderate' : '', moderate > 0 ? moderate : '');
      }
      if (!Ext.isDefined(result)) {
        result = me.renderNotAvailable(metadata);
      }
    }
    return '<div ' + (metadata.attr || '') + '>' + result + '</div>';
  },

  /**
   * Render license threat column.
   *
   * @private
   * @param {NX.coreui.model.Component} model component model
   * @returns {String} rendered value
   */
  renderLicenseThreat: function(model) {
    var me = this,
        metadata = {},
        result, licenseThreat, licenseThreatName, barClass = '';

    result = me.renderPreconditions(model, metadata);
    if (!result) {
      licenseThreat = model.get('healthCheckLicenseThreat');
      licenseThreatName = model.get('healthCheckLicenseThreatName');
      if (licenseThreat === 0 || licenseThreat > 0) {
        if (licenseThreat === 4) {
          barClass = 'critical';
        }
        else if (licenseThreat === 2) {
          barClass = 'moderate';
        }
        else if (licenseThreat === 1) {
          barClass = 'none';
        }
        else {
          barClass = 'severe';
        }
        return '<span class="nx-clm-chiclet-small ' + barClass + '" style="width: auto; padding: 1px 2px; font-size: inherit;">' + licenseThreatName + '</span>';
      }
      if (!Ext.isDefined(result)) {
        result = me.renderNotAvailable(metadata);
      }
    }
    return '<div ' + (metadata.attr || '') + '>' + result + '</div>';
  },

  /**
   * Render value based on preconditions.
   *
   * @private
   * @param {NX.coreui.model.Component} model component model
   * @param metadata column metadata
   * @returns {*} rendered value
   */
  renderPreconditions: function(model, metadata) {
    var edition = NX.State.getEdition(),
        util = NX.coreui.util.HealthCheckUtil;

    if ('EVAL' === edition || 'OSS' === edition) {
      metadata.attr = 'data-qtip="' + NX.I18n.get('HealthCheckInfo_Tooltip') + '"';
      return util.iconSpan('fa-lock', 'opacity: 0.33;');
    }
    else if (!NX.State.getUser()) {
      metadata.attr = 'data-qtip="' + NX.I18n.get('HealthCheckInfo_LoggedInOnly_Tooltip') + '"';
      return util.iconSpan('fa-lock', 'opacity: 0.33;');
    }
    else if (!NX.Permissions.check('nexus:healthcheckalerts:update')) {
      metadata.attr = 'data-qtip="' + NX.I18n.get('HealthCheckInfo_NoPermission_Tooltip') + '"';
      return util.iconSpan('fa-lock', 'opacity: 0.33;');
    }
    else if (model.get('healthCheckLoading')) {
      return NX.I18n.get('HealthCheckInfo_Loading_Text');
    }
    else if (model.get('healthCheckDisabled')) {
      metadata.attr = 'data-qtip="' + NX.I18n.get('HealthCheckInfo_Disabled_Tooltip') + '"';
      return util.iconSpan('fa-info-circle', 'opacity: 0.33;');
    }
    else if (model.get('healthCheckError')) {
      metadata.attr = 'data-qtip="' + NX.I18n.get('HealthCheckInfo_Error_Tooltip') + '"';
      return util.iconSpan('fa-exclamation-triangle', 'color: red;');
    }
    else if (model.get('healthCheckCapped')
        || (model && model.get('cappedAlerts'))) {
      metadata.attr = 'data-qtip="' + NX.I18n.get('HealthCheckInfo_Quota_Tooltip') + '"';
      return util.iconSpan('fa-exclamation-triangle', 'color: yellow;');
    }
    return undefined;
  },

  /**
   * Render a not available value (no data).
   *
   * @private
   * @param metadata column metadata
   * @returns {String} rendered value
   */
  renderNotAvailable: function(metadata) {
    metadata.attr = 'data-qtip="' + NX.I18n.get('HealthCheckInfo_Unavailable_Tooltip') + '"';
    return NX.coreui.util.HealthCheckUtil.iconSpan('fa-ban', 'opacity: 0.33;');
  }

});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * Registers all feature groups for proui.
 *
 * @since 3.0
 */
Ext.define('NX.proui.controller.FeatureGroups', {
  extend: 'NX.app.Controller',
  requires: [
    'NX.I18n'
  ],

  /**
   * @override
   */
  init: function () {
    this.getApplication().getFeaturesController().registerFeature([
      {
        mode: 'admin',
        path: '/CLM',
        text: 'IQ Server',
        description: 'IQ Server integration',
        group: true,
        weight: 70,
        iconConfig: {
          file: 'three_tags.png',
          variants: ['x16', 'x32']
        }
      }
    ]);
  }

});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * Health Check Asset details controller.
 *
 * Shows healthcheck details when asset details are shown.
 *
 * @since 3.0
 */
Ext.define('NX.proui.controller.HealthCheckAssetDetail', {
  extend: 'NX.app.Controller',
  requires: [
    'NX.Permissions',
    'NX.State'
  ],

  views: [
    'healthcheck.HealthCheckAssetDetail'
  ],

  /**
   * @override
   */
  init: function() {
    var me = this;

    me.listen({
      component: {
        'nx-coreui-component-assetcontainer': {
          updated: me.onUpdated
        }
      }
    });
  },

  /**
   * Shows Health Check information about selected asset if user is logged in, has "nexus:healthcheckalerts:update" and
   * we have a PRO edition.
   *
   * @private
   * @param {NX.coreui.view.component.AssetContainer} container asset container
   * @param {NX.coreui.model.Asset} assetModel selected asset
   */
  onUpdated: function(container, assetModel) {
    var edition = NX.State.getEdition(),
        panel = container.down('nx-proui-healthcheck-healthcheckassetdetail');

    if (NX.State.getUser()
        && NX.Permissions.check('nexus:healthcheckalerts:read')
        && !('EVAL' === edition || 'OSS' === edition)) {
      if (!panel) {
        container.addTab(
            {
              xtype: 'nx-proui-healthcheck-healthcheckassetdetail',
              title: NX.I18n.get('Component_AssetInfo_HealthCheck_Title'),
              itemId: 'healthCheckInfo',
              weight: 30,
              minHeight: 600
            }
        );
        panel = container.down('nx-proui-healthcheck-healthcheckassetdetail');
      }

      panel.showInfo(assetModel);
    }
    else if (panel) {
      container.remove(panel);
    }
  }

});

/*
 * Copyright (c) 2008-present Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global Ext, NX*/

/**
 * Licensing controller.
 *
 * @since 3.0
 */
Ext.define('NX.proui.controller.Licensing', {
  extend: 'NX.app.Controller',
  requires: [
    'NX.Conditions',
    'NX.Permissions',
    'NX.Messages',
    'NX.Security',
    'NX.I18n'
  ],

  views: [
    'licensing.LicenseAgreement',
    'licensing.LicensingDetails'
  ],

  refs: [
    {
      ref: 'panel',
      selector: 'nx-proui-licensing-details'
    }
  ],

  /**
   * @override
   */
  init: function () {
    var me = this;

    me.getApplication().getFeaturesController().registerFeature({
      mode: 'admin',
      path: '/System/Licensing',
      text: NX.I18n.get('Licensing_Text'),
      description: NX.I18n.get('Licensing_Description'),
      view: { xtype: 'nx-proui-licensing-details' },
      iconConfig: {
        file: 'license_key.png',
        variants: ['x16', 'x32']
      },
      visible: function () {
        return NX.Permissions.check('nexus:licensing:read');
      }
    }, me);

    me.listen({
      component: {
        'nx-proui-licensing-details button[action=install]': {
          click: me.install,
          afterrender: me.bindInstallButton
        },
        'nx-proui-licensing-details button[action=uninstall]': {
          click: me.uninstall,
          afterrender: me.bindUninstallButton
        },
        'nx-proui-licensing-agreement button[action=agree]': {
          click: me.onAgree
        }
      }
    });
  },

  /**
   * @private
   */
  showAgreementWindow: function () {
    return Ext.widget('nx-proui-licensing-agreement');
  },

  /**
   * @private
   * Install license, as user agreed.
   */
  onAgree: function (button) {
    var win = button.up('window'),
        form = win.licenseForm,
        authToken = win.authToken;

    win.close();
    form.submit({
      params: {
        authToken: authToken
      },
      success: function () {
        form.isValid();
        NX.Messages.add({ text: NX.I18n.get('Licensing_Install_Success'), type: 'success' });
        this.getController('Refresh').refresh();
      }
    });
  },

  /**
   * @override
   * @private
   * Enable 'Install' when user has 'create' permission.
   */
  bindInstallButton: function (button) {
    button.mon(
        NX.Conditions.and(
            NX.Conditions.isPermitted('nexus:licensing:create')
        ),
        {
          satisfied: button.enable,
          unsatisfied: button.disable,
          scope: button
        }
    );
  },

  /**
   * @override
   * @private
   * Enable 'Uninstall' when user has 'delete' permission.
   */
  bindUninstallButton: function (button) {
    button.mon(
        NX.Conditions.and(
            NX.Conditions.isPermitted('nexus:licensing:delete')
        ),
        {
          satisfied: button.enable,
          unsatisfied: button.disable,
          scope: button
        }
    );
  },

  /**
   * @private
   * Install a license after successful authentication.
   */
  install: function (button) {
    var me = this,
        form = button.up('form');
    NX.Security.doWithAuthenticationToken(
        NX.I18n.format('Licensing_Authentication_Validation', 'Installing'),
        {
          success: function (authToken) {
            Ext.apply(me.showAgreementWindow(), { licenseForm: form, authToken: authToken });
          }
        }
    );
  },

  /**
   * @private
   * Uninstall current license after successful authentication.
   */
  uninstall: function () {
    NX.Security.doWithAuthenticationToken(
        NX.I18n.format('Licensing_Authentication_Validation', 'Uninstalling'),
        {
          success: function (authToken) {
            NX.direct.licensing_Licensing.uninstall(authToken, function (response) {
              if (Ext.isDefined(response) && response.success) {
                NX.Messages.add({ text: NX.I18n.get('Licensing_Uninstall_Success'), type: 'success' });
              }
            });
          }
        }
    );
  }

});

